import java.io.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.filter.*;

import java.util.List;
import java.util.Iterator;

public class Exemple2 {
   static org.jdom.Document document;
   static Element racine;

   public static void main(String[] args) {
      //On cre une instance de SAXBuilder
      SAXBuilder sxb = new SAXBuilder();
      try {
         //On cre un nouveau document JDOM avec en argument le fichier XML
         document = sxb.build(new File("exemple2.xml"));
      } catch(Exception e){}
      //On initialise un nouvel lment racine avec l'lment racine du document.
      racine = document.getRootElement();
      afficheTout();
      System.out.println("-------------");
      afficheFiltre();
   }
   static void afficheTout() {
      //On cre une List contenant tous les noeuds "etudiant" de l'Element racine
      List listEtudiants = racine.getChildren("etudiant");

      //On cre un Iterator sur notre liste
      Iterator i = listEtudiants.iterator();
      while(i.hasNext()) {
         //On recre l'Element courant  chaque tour de boucle afin de
         //pouvoir utiliser les mthodes propres aux Element comme :
         //selectionner un noeud fils, modifier du texte, etc...
         Element courant = (Element)i.next();
         //On affiche le nom de l'element courant
         System.out.println(courant.getChild("nom").getText());
      }
   }
   static void afficheFiltre() {
      //On cre un nouveau filtre
      Filter filtre = new Filter() {
         //On dfinit les proprits du filtre  l'aide
         //de la mthode matches
         public boolean matches(Object ob) {
            //1re vrification : les objets filtrs sont bien des Elements
            if(!(ob instanceof Element)) return false;
            //On cre alors un Element sur lequel on va faire les vrifications voulues.
            Element element = (Element)ob;
            //On cre des variables qui vont nous permettre de vrifier les conditions
            boolean verifNom = false, verifPrenom = false;
            //2me vrification: on vrifie que le nom est bien "Durant"
            if(element.getChild("nom").getTextTrim().equals("Durant")) verifNom = true;
            //3me vrification: on vrifie que Durant possde un prenom "Pierre"
            //On commence par vrifier que la personne possde un prenom,
            //en effet notre fichier XML possde des tudiants sans prnom !
            Element prenoms = element.getChild("prenoms");
            if (prenoms == null) return false;
            //On constitue une liste avec tous les prenoms
            List listprenom = prenoms.getChildren("prenom");
            //On effectue la vrification en parcourant la liste de prenoms
            Iterator i = listprenom.iterator();
            while(i.hasNext()) {
               Element courant = (Element)i.next();
               if (courant.getText().equals("Pierre")) verifPrenom = true;
            }
            //Si nos conditions sont remplies on retourne true, false sinon
            return (verifNom && verifPrenom);
         }
       };//Fin du filtre
      System.out.println("Recherche des tudiants de nom Durant prnomms Pierre");
      //getContent va utiliser notre filtre pour crer une liste d'tudiants rpondant aux critres.
      List resultat = racine.getContent(filtre);
      //On affiche enfin l'attribut classe de tous les lments retenus de notre liste
      Iterator i = resultat.iterator();
      while(i.hasNext()) {
         Element courant = (Element)i.next();
         System.out.println("Un tudiant de nom Durant et prnomm Pierre est en " + courant.getAttributeValue("classe"));
      }
   }
}