import java.io.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

import java.util.List;
import java.util.Iterator;

public class Exemple3 {
   static org.jdom.Document document;
   static Element racine;

   public static void main(String[] args) {
       try {
          lireFichier("Exercice2.xml");
          affiche();
          supprElement("prenoms");
          System.out.println("-----------------");
          affiche();
          enregistreFichier("exemple3.xml");
        } catch(Exception e){}
   }

   //On parse le fichier et on initialise la racine de notre arborescence
   static void lireFichier(String fichier) throws Exception {
      SAXBuilder sxb = new SAXBuilder();
      document = sxb.build(new File(fichier));
      racine = document.getRootElement();
   }

   //On fait des modifications sur un Element
   static void supprElement(String element) {
      //Dans un premier temps on liste tous les tudiants
      List listEtudiant = racine.getChildren("etudiant");
      Iterator i = listEtudiant.iterator();
      //On parcourt la liste grce  un iterator
      while (i.hasNext()) {
         Element courant = (Element)i.next();
         //Si l'etudiant possde l'Element en question on applique les modifications.
         if(courant.getChild(element)!=null) {
            //On supprime l'Element en question
            courant.removeChild(element);
            //On renomme l'Element pre sachant qu'une balise XML n'accepte
            //ni les espaces ni les caractres spciaux
            //"etudiant modifi" devient "etudiant_modifie"
            courant.setName("etudiant_modifie");
         }
      }
   }

   //On enregistre notre nouvelle arborescence dans le fichier d'origine dans un format classique.
   static void enregistreFichier(String fichier) throws Exception {
         XMLOutputter sortie = new XMLOutputter(Format.getPrettyFormat());
         sortie.output(document, new FileOutputStream(fichier));
   }

   static void affiche() {
	      try {
	         //On utilise ici un affichage classique avec getPrettyFormat()
	         XMLOutputter sortie = new XMLOutputter(Format.getPrettyFormat());
	         sortie.output(document, System.out);
	      }
	      catch (java.io.IOException e){}
	   }
}